#ifndef _EXTERNAL_H_
#define _EXTERNAL_H_

// External DLL handle
#define MAX_DLLS  1024
#define MAX_HLPS  128
#include "output.h"

// Function prototypes
typedef bool Init_func(void);
typedef int NewDecode_func(OutputTree *otp, unsigned char *packet, int pack_size, __int64 protid, int curLevel, int &CountBits, int isSummary,  NewCString& ProtName, int ByteOrder, int DataTypeByteOrder, int DataFieldByteOrder);
typedef void Filter_func(OutputTree *tree);
typedef void Config_func(HWND window);
typedef void Event_func(HWND window, bool create);
typedef void Drop_func(__int64 ids[], int count);
typedef bool Test_func(int port);
typedef void SetPorts_func(int *ports, int size);
typedef bool Service_func(__int64 id);
typedef bool Validate_func(__int64 id);
typedef unsigned char *GetPacket_func(__int64 id, int *packetLen, short *hour,	short *min, short *sec, short *msec);
typedef int SendPacket_func(unsigned char *packet, unsigned short len);

// External decoder registration
enum proto_enum {
	proto_enum_tcp		 = 1,
	proto_enum_udp		 = 2,
	proto_enum_sap		 = 3,
  proto_enum_etype	 = 4,
  proto_enum_ipproto = 5
};
__declspec(dllimport) bool RegisterDecoder(proto_enum proto, int port, NewDecode_func *func);
__declspec(dllimport) bool RegisterDecodeAs(proto_enum proto, char *shortName, NewDecode_func *func, Config_func *config, Test_func *test);
__declspec(dllimport) bool RegisterHelp(char *name, char *path);
__declspec(dllimport) void Reset();
__declspec(dllimport) bool SetTreeFilter(Filter_func *func);
__declspec(dllimport) bool RegisterService(const char *serviceName, Service_func *sfunc);
__declspec(dllimport) bool RegisterPopupService(const char *serviceName, Service_func *sfunc, Validate_func *vfunc);
__declspec(dllimport) unsigned char *getPacket(__int64 id, int *packetLen, short *hour,	short *min, short *sec, short *msec);
__declspec(dllimport) void freePacket(PVOID pointer);
__declspec(dllimport) int sendPacket(unsigned char *packet, unsigned short len);

#endif //_EXTERNAL_H_
